<?php

namespace Modules\Catalogue\Validator;

use Entity\Model\CFormats;
use Helpers\Trad\ITrad;
use Helpers\Validator\Validator;

class FormatValidator extends Validator
{
    public function __construct(\PDO $pdo, ITrad $trad)
    {
        $this->pdo = $pdo;
        $this->trad = $trad;
    }

    /**
     * @param array<mixed> $post
     * @return void
     */
    public function validateForm(&$post)
    {
        $this->isStringAvecEspace($this->trad->t('Identification du format'), $post['IDFORMAT'], 1, 30);

        $infoFormat = (new CFormats($this->pdo))->find($post['IDFORMAT']);
        $this->isTrue($infoFormat, $this->trad->t('Ce code existe déjà.'));

        $this->isStringAvecEspace($this->trad->t('Description du format'), $post['DESCFRMT'], 1, 128);

        if ($post['TYPDATAS'] == 'OCI') {
            $this->isStringAvecEspace($this->trad->t('Identifiant panier fournisseur'), $post['RACINEXML_OCI'], 0, 128);
            $post['RACINEXML'] = $post['RACINEXML_OCI'];
        }

        if ($post['TYPDATAS'] == 'cXML') {
            $this->isStringAvecEspace($this->trad->t('Identifiant panier fournisseur'), $post['RACINEXML_CXML'], 0, 128);
            $post['RACINEXML'] = $post['RACINEXML_CXML'];

            // $this->isCheck($post['BASE64']);
        }
    }

    /**
     * @param array<mixed> $post
     * @param array<mixed> $connecteur
     * @return void
     */
    public function validateConnecteur($post, &$connecteur):void
    {
        foreach ($post['IDCLE'] as $k => $v) {
            $connecteur[] = [
                'IDCLE'         => $post['IDCLE'][$k],
                'ORDRE'         => $post['ORDRE'][$k],
                'NOM_PARAMETRE' => $post['NOM_PARAMETRE'][$k],
                'VALEUR_PARAM'  => $post['VALEUR_PARAM'][$k],
                'TYPE_PARAM'    => $post['TYPE_PARAM'][$k],
            ];
        }

        foreach ($connecteur as $k => $c) {
            $index = $k+1;

            $this->isObligatoire($c['IDCLE'], $index.' - '.$this->trad->t('IDCLE'));
            $this->isInteger($index.' - '.$this->trad->t('ORDRE'), $c['ORDRE'], 1, 9);
            $this->isObligatoire($c['NOM_PARAMETRE'], $index.' - '.$this->trad->t('NOM PARAMETRE'));
            $this->isStringAvecEspace($index.' - '.$this->trad->t('VALEUR_PARAM'), $c['VALEUR_PARAM'], 1, 255);
            $this->isObligatoire($c['TYPE_PARAM'], $index.' - '.$this->trad->t('TYPE PARAM'));
        }
    }
}
